/*
	Definition of basic functions and variables
	
	This file is part of Smartk, a smart card framework for the Linux Kernel.
	Copyright (C) 2003	Luigi Catuogno		<luicat@dia.unisa.it>
						Roberto Gassira'	<robgas@dia.unisa.it>
						Michele Masullo		<micmas@dia.unisa.it>
	
    Smartk is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Smartk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _BASE_H
#define _BASE_H

#define OK 						0
#define FAIL					-1

#ifndef TRUE
	#define TRUE  1
#endif

#ifndef FALSE
	#define FALSE 0
#endif

typedef int bool;
typedef unsigned char BYTE;

/*	Min e Max	*/
#ifndef MIN
#define MIN(a,b)    ((a) < (b) ? (a) : (b))
#endif

#ifndef MAX
#define MAX(a,b)        ((a)>(b)?(a):(b))
#endif


/* Invert order of bits in a byte: b7->b0, b0->b7 */
#ifndef INVERT_BYTE
#define INVERT_BYTE(a)    ((((a) << 7) & 0x80) | \
        (((a) << 5) & 0x40) | \
        (((a) << 3) & 0x20) | \
        (((a) << 1) & 0x10) | \
        (((a) >> 1) & 0x08) | \
        (((a) >> 3) & 0x04) | \
        (((a) >> 5) & 0x02) | \
        (((a) >> 7) & 0x01))
#endif

#endif /* share.h */
