/*
	Test program
	
	This file is part of Smartk, a smartcard framework for the Linux Kernel.
	Copyright (C) 2003	Luigi Catuogno		<luicat@dia.unisa.it>
						Roberto Gassira'	<robgas@dia.unisa.it>
						Michele Masullo		<micmas@dia.unisa.it>
	
    Smartk is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Smartk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define FILEZ "/dev/smartk"

typedef unsigned char BYTE;

void send_and_receive(int fd, char * name, char * cmd){
	int ret = -1, lenr,i;
	int lenc = strlen(cmd);
	BYTE reply[256];
	
	printf("%s:\nComando:%s\n",name, cmd);
	if(write(fd, cmd, lenc) != lenc){
		perror("Impossibile scrivere sul device\n");	
	}
	else
	/*	Lettura della risposta	*/
	if( (lenr = read(fd, reply, 1024)) < 0)
		perror("Errore nella lettura\n");
	else
		ret = 0;
	
	if(ret != 0){
		printf("Errore nella operazione %s\n", name);
		exit(EXIT_FAILURE);
	}
	printf("Risposta:");
	for(i = 0; i < lenr; i++)
		printf("%02X ", reply[i]);
	printf("\n");
	
}


int main(int argc, char **argv){
	BYTE reply[255];
	int fd, lenc, lenr;

	if(argc != 2){
		printf("%s x \n 1 = ISO 7816\n 2 = JavaCard\n", argv[0]);
		return -1;
	}
	
	/*	Apertura device	*/
	if((fd = open(FILEZ, O_RDWR)) < 0){
    	perror("Errore apertura file :");
	}

	switch(argv[1][0]){
		case '1': /*	ISO 7816	*/
			send_and_receive(fd, "Verify", "80 20 00 02 08 32 32 32 32 32 32 32 32");			
			send_and_receive(fd, "Select File", "80 A4 00 00 02 3F 11 00");
			send_and_receive(fd, "Read Binary", "80 B0 00 00 02");	
			break;
		case '2': /*	JavaCard	*/
			send_and_receive(fd, "Select Applet", "00 A4 04 00 10 A0 00 00 00 18 FF 00 00 00 00 00 00 00 00 00 02");
			sleep(1);
			send_and_receive(fd, "Get length master repository", "F1 CE 00 00 01");
			send_and_receive(fd, "Get length local repository", "F1 DE 00 00 01");	
			//send_and_receive(fd, "Get length free slots in Master", "F1 CD 00 00 01");	
			//send_and_receive(fd, "Get length free slots in Local", "F1 DD 00 00 01");		
			//Richiesta prima chiave
			//send_and_receive(fd, "Get first key hash", "F1 CF 00 00 00");
			sleep(1);
			send_and_receive(fd, "Get first key hash", "F1 CA 01 00 80");
			//send_and_receive(fd, "Get first key hash", "F1 CA 02 00 00");
		//send_and_receive(fd, "Get Info", "F1 01 00 00 00");
			//send_and_receive(fd, "Varify Pin Prova Errata", "F1 C0 00 00 07 01 02 03 04 05 06 07");
			//send_and_receive(fd, "Varify Pin Prova Corretta", "F1 C0 00 00 08 01 02 03 04 05 06 07 08");
			//send_and_receive(fd, "Cifratura", "90 01 00 00 08 01 02 03 04 05 06 07 08 08");
			//send_and_receive(fd, "Decifratura", "90 02 00 00 08 E7 F0 9B 88 7C E7 FA 8E 08");
	}
	
	/*	Chiusura device	*/
	close(fd);
	
}
